// Code generated by protoc-gen-connect-go. DO NOT EDIT.
//
// Source: gateway/guesses/v1/guesses.proto

package guessesv1connect

import (
	connect "connectrpc.com/connect"
	context "context"
	errors "errors"
	v1 "gitlab.com/binarygame/microservices/gateway/pkg/gen/gateway/guesses/v1"
	http "net/http"
	strings "strings"
)

// This is a compile-time assertion to ensure that this generated file and the connect package are
// compatible. If you get a compiler error that this constant is not defined, this code was
// generated with a version of connect newer than the one compiled into your binary. You can fix the
// problem by either regenerating this code with an older version of connect or updating the connect
// version compiled into your binary.
const _ = connect.IsAtLeastVersion1_13_0

const (
	// GuessesServiceName is the fully-qualified name of the GuessesService service.
	GuessesServiceName = "gateway.guesses.v1.GuessesService"
)

// These constants are the fully-qualified names of the RPCs defined in this package. They're
// exposed at runtime as Spec.Procedure and as the final two segments of the HTTP route.
//
// Note that these are different from the fully-qualified method names used by
// google.golang.org/protobuf/reflect/protoreflect. To convert from these constants to
// reflection-formatted method names, remove the leading slash and convert the remaining slash to a
// period.
const (
	// GuessesServiceSubmitGuessProcedure is the fully-qualified name of the GuessesService's
	// SubmitGuess RPC.
	GuessesServiceSubmitGuessProcedure = "/gateway.guesses.v1.GuessesService/SubmitGuess"
)

// These variables are the protoreflect.Descriptor objects for the RPCs defined in this package.
var (
	guessesServiceServiceDescriptor           = v1.File_gateway_guesses_v1_guesses_proto.Services().ByName("GuessesService")
	guessesServiceSubmitGuessMethodDescriptor = guessesServiceServiceDescriptor.Methods().ByName("SubmitGuess")
)

// GuessesServiceClient is a client for the gateway.guesses.v1.GuessesService service.
type GuessesServiceClient interface {
	// Registers a new user in the system, providing a unique id and private key for authentication.
	SubmitGuess(context.Context, *connect.Request[v1.SubmitGuessRequest]) (*connect.Response[v1.SubmitGuessResponse], error)
}

// NewGuessesServiceClient constructs a client for the gateway.guesses.v1.GuessesService service. By
// default, it uses the Connect protocol with the binary Protobuf Codec, asks for gzipped responses,
// and sends uncompressed requests. To use the gRPC or gRPC-Web protocols, supply the
// connect.WithGRPC() or connect.WithGRPCWeb() options.
//
// The URL supplied here should be the base URL for the Connect or gRPC server (for example,
// http://api.acme.com or https://acme.com/grpc).
func NewGuessesServiceClient(httpClient connect.HTTPClient, baseURL string, opts ...connect.ClientOption) GuessesServiceClient {
	baseURL = strings.TrimRight(baseURL, "/")
	return &guessesServiceClient{
		submitGuess: connect.NewClient[v1.SubmitGuessRequest, v1.SubmitGuessResponse](
			httpClient,
			baseURL+GuessesServiceSubmitGuessProcedure,
			connect.WithSchema(guessesServiceSubmitGuessMethodDescriptor),
			connect.WithClientOptions(opts...),
		),
	}
}

// guessesServiceClient implements GuessesServiceClient.
type guessesServiceClient struct {
	submitGuess *connect.Client[v1.SubmitGuessRequest, v1.SubmitGuessResponse]
}

// SubmitGuess calls gateway.guesses.v1.GuessesService.SubmitGuess.
func (c *guessesServiceClient) SubmitGuess(ctx context.Context, req *connect.Request[v1.SubmitGuessRequest]) (*connect.Response[v1.SubmitGuessResponse], error) {
	return c.submitGuess.CallUnary(ctx, req)
}

// GuessesServiceHandler is an implementation of the gateway.guesses.v1.GuessesService service.
type GuessesServiceHandler interface {
	// Registers a new user in the system, providing a unique id and private key for authentication.
	SubmitGuess(context.Context, *connect.Request[v1.SubmitGuessRequest]) (*connect.Response[v1.SubmitGuessResponse], error)
}

// NewGuessesServiceHandler builds an HTTP handler from the service implementation. It returns the
// path on which to mount the handler and the handler itself.
//
// By default, handlers support the Connect, gRPC, and gRPC-Web protocols with the binary Protobuf
// and JSON codecs. They also support gzip compression.
func NewGuessesServiceHandler(svc GuessesServiceHandler, opts ...connect.HandlerOption) (string, http.Handler) {
	guessesServiceSubmitGuessHandler := connect.NewUnaryHandler(
		GuessesServiceSubmitGuessProcedure,
		svc.SubmitGuess,
		connect.WithSchema(guessesServiceSubmitGuessMethodDescriptor),
		connect.WithHandlerOptions(opts...),
	)
	return "/gateway.guesses.v1.GuessesService/", http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		switch r.URL.Path {
		case GuessesServiceSubmitGuessProcedure:
			guessesServiceSubmitGuessHandler.ServeHTTP(w, r)
		default:
			http.NotFound(w, r)
		}
	})
}

// UnimplementedGuessesServiceHandler returns CodeUnimplemented from all methods.
type UnimplementedGuessesServiceHandler struct{}

func (UnimplementedGuessesServiceHandler) SubmitGuess(context.Context, *connect.Request[v1.SubmitGuessRequest]) (*connect.Response[v1.SubmitGuessResponse], error) {
	return nil, connect.NewError(connect.CodeUnimplemented, errors.New("gateway.guesses.v1.GuessesService.SubmitGuess is not implemented"))
}
